#include <stdlib.h>
#include <stdio.h>
#include <pthread.h>
#include "smart_pointers.h"

/* simple data structure */
struct data {
  double x;
  double y;
  double z;
};

/* print the values of a data structure */
void print_values(struct data*ptr) {
  printf("x = %f\n", ptr->x);
  printf("y = %f\n", ptr->y);
  printf("z = %f\n", ptr->z);
}

/* to some things on a data structure */
void do_things(struct smart_pointer *sm_ptr, int n) {

  if(n<1)
    return;

  struct data* ptr = new_pointer(sm_ptr);
  int i;
  for(i=0; i<n; i++) {
    ptr->x = ptr->x + ptr->x;
    ptr->y = ptr->y + i;
    ptr->z = ptr->z + ptr->x;
  }
  do_things(sm_ptr, n-1);

  smart_pointer_free(sm_ptr);
}

int main(int argc, char**argv) {
  struct smart_pointer sm_ptr;
  init_smart_malloc(&sm_ptr, sizeof(struct data));
  struct data* ptr = new_pointer(&sm_ptr);

  /* initialize the data structure */
  ptr->x = 3.27;
  ptr->y = 1.42;
  ptr->z = 0.79;

  print_values(ptr);

  do_things(&sm_ptr, 10);

  printf("Results:\n");
  print_values(ptr);

  smart_pointer_free(&sm_ptr);

  return EXIT_SUCCESS;
}
